jQuery(document).ready(function($){
  var exportData = $("#exportData");
  
  function prepareData(){
    var bb = new Blob([exportData.val()], { type: 'text/plain' });
	  var a = document.createElement('a');
    a.download = 'tPlayer_backup_data.sql';
    a.href = window.URL.createObjectURL(bb);
    a.textContent = 'Download ready';
    a.style='display:none';
    a.click();
  }
  
  // click export btn
  $("#wptpa_export").on("click", function(){
    // ajax
    var data = {
      action: "wptpa_export_data"
    };
    $.ajax({
      type: "POST",
      url: ajaxurl,
      data: data,
      beforeSend: function () {
        // loader
        $(".data_prepare").addClass("active");
        $(".data_loading").addClass("active");
      },
      success: function (response) {
        $(".data_prepare").removeClass("active");
        $(".data_loading").removeClass("active");
        $(".data_ready_export").addClass("active");
        console.log(response);
        exportData.val(response);
        prepareData();
      }
    });
  });
  
  // click import btn
  $("#wptpa_import_button").on("click", function(e){
    e.preventDefault();
    // ajax
    $("#wptpa_import_input").click();
  });
  $("#wptpa_import_input").on("change", function(){
    $("#wptpa_import_form").submit();
  });
});
