<?php
function wptpa_playlists_page() {
  global $wpdb;
  $songs_table_name = $wpdb->prefix."tpa_songs";
  $playlists_table_name = $wpdb->prefix."tpa_playlist";
  $notify = ""; // уведомления
  $heading = __('Playlists', 'wptpa'); // заголовок
  
  // получаем action
  if(isset($_GET['action'])){
    $action = $_GET['action'];
  } else {
    if(isset($_POST['action'])){
      $action = $_POST['action'];
    } else {
      $action = false;
    }
  }
  // если прислан action
  if($action){
    switch ($action) {
      case 'create':
        $heading = __('Create Playlist', 'wptpa');
        break;
      case 'edit':
        $itemid = $_GET['itemid'];
        $heading = __('Edit Playlist', 'wptpa');
        // получаем плейлист
        $playlist = $wpdb->get_row("SELECT * FROM $playlists_table_name WHERE id = ".$itemid, ARRAY_A);
        $playlist["items"] = unserialize($playlist["items"]);
        break;
      case 'clone':
        $action = false;
        $id = $_GET['itemid'];
        // получаем имя копируевомого плейлиста
        $playlist = $wpdb->get_row("SELECT name FROM $playlists_table_name WHERE id = ".$id, ARRAY_A);
        $playlist_name = $playlist['name']. " Copy";
        // получаем плейлист
        $data = $wpdb->get_row("SELECT name, items FROM $playlists_table_name WHERE id = ".$id, ARRAY_A);
        $data['name'] = $playlist_name;
				$data["items"] = unserialize($data["items"]);
				if($data["items"]){
					foreach($data["items"] as $key => $value){
						$song = $wpdb->get_row("SELECT * FROM $songs_table_name WHERE id = ".$value, ARRAY_A);
						unset($song['id']);
						// добавляем в бд
						$wpdb->insert($songs_table_name, $song);
						//получаем и записываем айди
						$id = $wpdb->insert_id;
						$id_array[] = $id;
					}
					$data["items"] = serialize($id_array);
				} else {
					$data["items"] = "";
				}
        // клонируем
        $wpdb->insert($playlists_table_name, $data);
        // выводим информацию
        $msg = __("Playlist", 'wptpa').", <b>$playlist_name</b> ".__("was Cloned", 'wptpa').".";
        $notify .= 'notifyFW.send({"heading": "'.__('Clone Playlist', 'wptpa').'","text": "'.$msg.'"});';
        break;
      case 'delete':
        $action = false; // очищаем action, для того что бы вывести спико плейлистов
        // если присланы айди удаляем нет выводим ошибку
        if(isset($_GET['itemid']) OR isset($_POST['idList'])){
          //получаем айди может быть как один так и несколько через пост
          $id = isset($_GET['itemid']) ? array(0 => $_GET['itemid']) : $_POST['idList'];
          // разбираем все айди
          $i = 0; // delay
          foreach($id as $k => $v){
            // получаем имя удаляемого плейлиста
            $playlist = $wpdb->get_row("SELECT name FROM $playlists_table_name WHERE id = ".$v, ARRAY_A);
            $playlist_name = $playlist['name'];
            // удаляем плейлист
            $wpdb->delete($playlists_table_name, array("id" => $v));
            $msg = __("Playlist", 'wptpa').", <b>$playlist_name</b> ".__("was Removed", 'wptpa').".";
            $notify .= 'notifyFW.send({"heading": "'.__('Delete Playlist', 'wptpa').'","text": "'.$msg.'"});';
            $i++;
          }
          // плейлист не выбран
        } else {
          // выводим ошибку
          $notify .= 'notifyFW.send({"heading": "'.__('Delete Playlist', 'wptpa').'","text": "'.__("Please, <b>Select</b> the item for Deleting.", 'wptpa').'"});';
        }
        break;
      case 'save':
        // очищаем єкшен
        $action = false;
        //проверяем прислан ли плейлист
        if(!empty($_POST)){
          // проверяем если прислан айди плейлиста значит сохраняем, иначе добовляем новый
          $itemid = isset($_GET['itemid']) ? $_GET['itemid'] : null;
          // проверяем есть ли название плейлиста
          $pls["name"] = !empty($_POST["playlist"]["name"]) ? $_POST["playlist"]["name"] : "Unnamed Playlist";
          // получаем массив треков
          $sngs = isset($_POST["playlist"]["items"]) ? $_POST["playlist"]["items"] : null;
          if($sngs){
            // массив айдишек для плейлиста
            $id_array = array();
            foreach($sngs as $key => $value){
              // если у трека нет айди значит новый, если есть значит старый
              if(!isset($value["id"])){
                // добавляем в бд
                $wpdb->insert($songs_table_name, $value);
                //получаем и записываем айди
                $id = $wpdb->insert_id;
                $id_array[] = $id;
              } else {
                // получаем айди
                $id = intval($value["id"]);
                // обновляем трек в бд
                $wpdb->update($songs_table_name, $value, array('id' => $id));
                //записываем айди
                $id_array[] = intval($value["id"]);
              }
            }
            //сериализуем список треков
            $pls["items"] = serialize($id_array);
          } else {
            $pls["items"] = "";
          }
          $playlist_name = $pls["name"];
          // проверяем если переменная айди плейлиста пустая, то новый плейлист, если нет то обновляем существующий
          if($itemid) {
            $msg = __("Playlist", 'wptpa').", <b>$playlist_name</b> ".__("was Saved", 'wptpa').".";
            $heading = __("Save Playlist", 'wptpa');
            // обновляем в бд
            $q = $wpdb->update($playlists_table_name, $pls, array('id' => $itemid));
          } else {
            $msg = __("Playlist", 'wptpa').", <b>$playlist_name</b> ".__("was Created", 'wptpa').".";
            // добпавляем в бд
            $q = $wpdb->insert($playlists_table_name, $pls);
            $heading = __("Create Playlist", 'wptpa');
          }
          // вывод мсдж плейлист добавден/обновлен
          $notify .= 'notifyFW.send({"heading": "'.$heading.'","text": "'.$msg.'"});';
        }
      break;
    }
  // action отсуствует значит это список плейлистов
  } 
  // кол-во записей на страницу
  $onpage = 10;
  //извлекаем номер текущей страницы, если отсуствует то берем первую
  $pagenum = isset($_GET["pagenum"]) ? $_GET["pagenum"] : 1;
  
  // если прислан тип сортировки получаем его
  $order = isset($_GET["order"]) ? $_GET["order"] : "id";
  // если прислан порядок сортировки получаем его
  $typeorder = isset($_GET["type"]) ? $_GET["type"] : "DESC";

  // cоздаем массив линков  
  $orderLinks["name"] = "?page=wptpa_playlists_page&pagenum=$pagenum&order=name&type=";
  $orderLinks["id"] = "?page=wptpa_playlists_page&pagenum=$pagenum&order=id&type=";
  
  //генерируем порядок сортировки
  switch($order) {
    case "name":
      $orderLinks["name"] .= $typeorder == "DESC" ? "ASC" : "DESC";
      $orderLinks["id"] .= "DESC";
    break;
    case "id":
      $orderLinks["name"] .= "ASC";
      $orderLinks["id"] .= $typeorder == "DESC" ? "ASC" : "DESC";
    break;
  }
    
  // Вытаскиваем кол-во записей
  $q = $wpdb->get_row("SELECT COUNT(id) AS count_playlist FROM $playlists_table_name", ARRAY_A);
  // кол-во записей
  $count_playlist = intval($q["count_playlist"]);
  // находим общие кол-во страниц
  $total = intval(($count_playlist - 1) / $onpage) + 1;
  //определяем начало записей для текущей страницы
  $pagenum = intval($pagenum);
  // Если значение $pagenum меньше единицы или отрицательно
  // переходим на первую страницу
  // А если слишком большое, то переходим на последнюю
  if(empty($pagenum) or $pagenum < 0) $pagenum =1;
  if($pagenum > $total) $pagenum = $total;
  // Вычисляем начиная к какого номера
  // следует выводить сообщения
  $start = $pagenum * $onpage - $onpage;
  // получаем плейлисты
  $playlists_list = $wpdb->get_results("SELECT * FROM $playlists_table_name ORDER by $order $typeorder LIMIT $start, $onpage", ARRAY_A);
  $playlists_list = stripslashes_deep($playlists_list);
?>
<div class="wrap">
  <div class="fw_wrapper" style="display: none;">
    <div class="fw_container shadow-depth-0 bg-white-01">
     <div class="fw_row">
       <div class="fw_column lg-6">
         <div class="h5"><?php echo $heading; ?></div>
       </div>
       <?php if(!$action) { ?>
       <div class="fw_column lg-6 fw_input_field">
         <input id="wptpa_search_playlist" type="text" placeholder="<?php _e('Search playlist', 'wptpa'); ?>" class="fw_filled">
         <div id="wptpa_search_results" class="shadow-depth-5 bg-white-01"></div>
       </div>
       <?php } ?>
     </div>
    </div>
    <?php if(!$action) { // если не прислан екшен ?>
      <!-- playlist list -->
	  <form action="?page=wptpa_playlists_page" method="post" class="fw_container shadow-depth-0 bg-white-01">
	    <?php if($playlists_list) { // если есть плейлисты выводим список  ?>
		<table id="wptpa_playlists_list" class="hl">
            <thead>
              <tr>
                <th class="fw_input_field">
                  <label>
                    <input id="select_all" type="checkbox" name="idList[]" value="">
                    <span class="fw_checkbox"></span>
                  </label>
                </th>
                <th title="<?php _e('Playlist Name', 'wptpa'); ?>"><a href="<?php echo $orderLinks["name"]; ?>"><?php _e('Playlist Name', 'wptpa'); ?></a> <i class="fas fa-sort"></i></th>
                <th title="<?php _e('Shortcode', 'wptpa'); ?>"><a href="<?php echo $orderLinks["id"]; ?>"><?php _e('Shortcode', 'wptpa'); ?></a> <i class="fas fa-sort"></i></th>
                <th title="<?php _e('Songs', 'wptpa'); ?>"><?php _e('Songs', 'wptpa'); ?></th>
                <th title="<?php _e('Action', 'wptpa'); ?>"><?php _e('Action', 'wptpa'); ?></th>
              </tr>
            </thead>
            <tbody>
              <?php print_playlists_list($playlists_list); ?>
            </tbody>
        </table>
		<?php } else { // если нет плейлистов в базе ?>
		<div class="txt_align_center wptpa_empty_pls">
          <img width="50px" src="<?php echo WPTPA_URL; ?>assets/img/information.svg">
          <h4><?php _e('No Playlist', 'wptpa'); ?></h4>
          <h6><?php _e('Create your first playlist', 'wptpa'); ?></h6>
        </div>
		<?php } ?>
		<div class="fw_row">
          <div class="fw_column lg-12 align_end">
            <button type="submit" name="action" value="delete" class="fw_btn red"><i class="far fa-trash-alt"></i>Delete</button>
            <button type="submit" name="action" value="create" class="fw_btn"><i class="fas fa-plus"></i>Create</button>
          </div>
        </div>
	  </form>
	  <?php
        // если больше одной страницы выводим навигацию
        if($total > 1){
          playlistPaginations($total, $pagenum, $order, $typeorder, "?page=wptpa_playlists_page");
        }
    } else { ?>
      <!-- main -->
      <div class="fw_container shadow-depth-0 bg-white-01 txt_align_center">
        <form action="admin.php?page=wptpa_playlists_page&action=save<?php echo isset($itemid) ? "&itemid=".$itemid : ""; ?>" method="POST">
          <!-- playlist list -->
          <div class="fw_row">
            <div class="fw_column lg-12 fw_input_field textlabel">
              <input type="text" id="name" name="playlist[name]" value="<?php echo isset($playlist) ? stripslashes_deep($playlist["name"]) : ""?>">
              <label for="plsname" class="fw_flying_label"><?php _e('Playlist Name', 'wptpa'); ?></label>
            </div>
          </div>
          <table id="wptpa_playlist" class="hl">
            <thead>
              <tr>
                <th class="fw_input_field">
                  <label>
                    <input id="select_all" type="checkbox" name="" value="">
                    <span class="fw_checkbox"></span>
                  </label>
                </th>
                <th colspan="5" class="txt_align_left"><?php _e('Songs', 'wptpa'); ?></th>
              </tr>
            </thead>
            <tbody>
              <?php
                if(isset($playlist["items"]) AND !empty($playlist["items"])){
                  print_playlist($playlist["items"]);
                } ?>
              <tr class="fw_container shadow-depth-0 bg-white-01 txt_align_center wptpa_empty_pls">
                <td colspan="6">
                  <img width="50px" src="<?php echo WPTPA_URL; ?>assets/img/information.svg">
                  <h4><?php _e('Empty Playlist', 'wptpa'); ?></h4>
                  <h6 class="fw_subheading"><?php _e('Add first song to the playlist', 'wptpa'); ?></h6>
                </td>
              </tr>
            </tbody>
          </table>
          <div class="fw_row">
            <div class="fw_column lg-3">
              <a href="#" id="set_covers" class="fw_btn flat sml"><i class="far fa-images"></i><?php _e('Set Cover For All Songs', 'wptpa'); ?></a>
            </div>
            <div class="fw_column lg-9 align_end">
              <a href="#song_modall" id="add_songs" class="fw_btn flat sml"><i class="fas fa-plus"></i><?php _e('Add', 'wptpa'); ?></a>
              <a href="#song_modall" id="edit_songs" class="fw_btn flat sml"><i class="fas fa-pencil-alt"></i><?php _e('Edit', 'wptpa'); ?></a>
              <a href="#" id="delete_song" class="fw_btn flat sml"><i class="fas fa-trash-alt"></i><?php _e('Delete', 'wptpa'); ?></a>
            </div>
          </div>
          <div class="fw_divider"></div>
          <div class="fw_row">
            <div class="fw_column lg-12 align_end">
              <a href="admin.php?page=wptpa_playlists_page" class="fw_btn red"><?php _e('Cancel', 'wptpa'); ?></a>
              <button type="submit" name="action" value="save" class="fw_btn"><?php _e('Save', 'wptpa'); ?></button>
            </div>
          </div>
        </form>
      </div>
    <?php } ?>
    <!-- modal -->
    <div id="song_modall" class="fw_modal shadow-depth-5 bg-white-01">
      <div class="fw_row">
        <div class="fw_column lg-10"><div class="h6">{heading}</div></div>
        <div class="fw_column lg-2 align_end"><i class="fas fa-times fw_close"></i></div>
      </div>
      <div class="fw_row">
        <div class="fw_column lg-12 fw_input_field textlabel">
          <input type="text" id="artist" value="">
          <label for="artist" class="fw_flying_label"><?php _e('Artist or Radio Name', 'wptpa'); ?></label>
        </div>
      </div>
      <div class="fw_row">
        <div class="fw_column lg-12 fw_input_field textlabel">
          <input type="text" id="title" value="">
          <label for="title" class="fw_flying_label"><?php _e('Title', 'wptpa'); ?></label>
        </div>
      </div>
      <div class="fw_row">
        <div class="fw_column lg-9 fw_input_field textlabel">
          <input type="text" id="audio" value="">
          <label for="title" class="fw_flying_label"><?php _e('Audio URL', 'wptpa'); ?></label>
        </div>
        <div class="fw_column lg-3 align_end">
          <button type="button" id="wptpa_select_audio" class="fw_btn"><?php _e('Browse', 'wptpa'); ?></button>
        </div>
      </div>
      <div class="fw_row">
        <div class="fw_column lg-9 fw_input_field textlabel">
          <input type="text" id="cover" value="">
          <label for="cover" class="fw_flying_label"><?php _e('Cover URL', 'wptpa'); ?></label>
        </div>
        <div class="fw_column lg-3 align_end">
          <button type="button" id="wptpa_select_cover" class="fw_btn"><?php _e('Browse', 'wptpa'); ?></button>
        </div>
      </div>
      <div class="fw_row">
        <div class="fw_column lg-12 fw_input_field textlabel">
          <input type="text" id="dwn" value="">
          <label for="dwn" class="fw_flying_label"><?php _e('Download Link', 'wptpa'); ?></label>
        </div>
      </div>
      <div class="fw_row">
        <div class="fw_column lg-12 fw_input_field textlabel">
          <input type="text" id="buy" value="">
          <label for="buy" class="fw_flying_label"><?php _e('Buy Link', 'wptpa'); ?></label>
        </div>
      </div>
      <div class="fw_row">
        <div class="fw_column lg-12 align_end">
          <a href="#" id="fw_mdl_cancel" class="fw_btn flat"><?php _e('Cancel', 'wptpa'); ?></a>
          <a href="#" id="fw_mdl_ok" class="fw_btn"><?php _e('Save', 'wptpa'); ?></a>
        </div>
      </div>
    </div>
    <div class="fw_notify_wrapper"></div>
  </div>
</div>
  <script>
  jQuery(document).ready(function($){
    <?php echo $notify; ?>
  });
  </script>
<?php
}
?>