<?php 
function wptpa_settings_page(){
// framework FW
require_once('fw_framework.php');

// проверяем присланніе настройки
function checkValues($values){
  $array["autoplay"] = isset($values["autoplay"]) ? (boolean)$values["autoplay"] : false;
  $array["preload"] = isset($values["preload"]) ? $values["preload"] : "auto";
  $array["compact"] = isset($values["compact"]) ? (boolean)$values["compact"] : false;
  $array["playlist"] = isset($values["playlist"]) ? (boolean)$values["playlist"] : false;
  $array["covers"] = isset($values["covers"]) ? (boolean)$values["covers"] : false;
  $array["shuffle"] = isset($values["shuffle"]) ? (boolean)$values["shuffle"] : false;
  $array["share"] = isset($values["share"]) ? (boolean)$values["share"] : false;
  $array["embed"] = isset($values["embed"]) ? (boolean)$values["embed"] : false;
  $array["stats"] = isset($values["stats"]) ? (boolean)$values["stats"] : false;
  $array["volume"] = intval($values["volume"]);
  $array["scrollbar"] = isset($values["scrollbar"]) ? intval($values["scrollbar"]) : 0;
  $array["font"] = isset($values["font"]) ? (boolean)$values["font"] : false;
  $array["window"] = isset($values["window"]) ? (boolean)$values["window"] : false;
  // radio
  $array["radio_cover"] = isset($values["radio_cover"]) ? (boolean)$values["radio_cover"] : false;
  $array["radio_interval"] = isset($values["radio_interval"]) ? (int)$values["radio_interval"] : 30;
  
  $array["ads"] = isset($values["ads"]) ? (boolean)$values["ads"] : false;
  $array["ads_mode"] = isset($values["ads_mode"]) ? $values["ads_mode"] : "seconds";
  
  $array["ads_interval_sec"] = isset($values["ads_interval_sec"]) ? intval($values["ads_interval_sec"]) : "";
    
  $array["ads_interval_song"] = isset($values["ads_interval_song"]) ? intval($values["ads_interval_song"]) : "";
  $array["ads_url"] = isset($values["ads_url"]) ? $values["ads_url"] : "";
  
  $array["cpblts"]["playlists_page"] = isset($values["cpblts"]["playlists_page"]) ? $values["cpblts"]["playlists_page"] : "edit_posts";
  $array["cpblts"]["statistics_page"] = isset($values["cpblts"]["statistics_page"]) ? $values["cpblts"]["statistics_page"] : "edit_posts";
  $array["cpblts"]["settings_page"] = isset($values["cpblts"]["settings_page"]) ? $values["cpblts"]["settings_page"] : "edit_posts";
  $array["cpblts"]["ads_page"] = isset($values["cpblts"]["ads_page"]) ? $values["cpblts"]["ads_page"] : "edit_posts";
  $array["cpblts"]["data_page"] = isset($values["cpblts"]["data_page"]) ? $values["cpblts"]["data_page"] : "edit_posts";
  // themes
  
  $array["theme"] = $values["theme"];
  
  // если выбрана тема, загружаем ее палитру, иначе берем настройки пользователя
  if($array["theme"] == "custom") {
    $array["colors"]["player"]["background"] = $values["colors"]["player"]["background"];
    $array["colors"]["player"]["color"] = $values["colors"]["player"]["color"];
    $array["colors"]["player"]["button"] = $values["colors"]["player"]["button"];
    $array["colors"]["player"]["button_active"] = $values["colors"]["player"]["button_active"];
    $array["colors"]["player"]["seek"] = $values["colors"]["player"]["seek"];
    $array["colors"]["player"]["progress"] = $values["colors"]["player"]["progress"];
    $array["colors"]["player"]["timecode"] = $values["colors"]["player"]["timecode"];
    $array["colors"]["playlist"]["background"] = $values["colors"]["playlist"]["background"];
    $array["colors"]["playlist"]["color"] = $values["colors"]["playlist"]["color"];
    $array["colors"]["playlist"]["background_current"] = $values["colors"]["playlist"]["background_current"];
    $array["colors"]["playlist"]["color_current"] = $values["colors"]["playlist"]["color_current"];
  } else {
    $custom = get_option("wptpa_optn");
    $array["colors"]["player"]["background"] = $custom["colors"]["player"]["background"];
    $array["colors"]["player"]["color"] = $custom["colors"]["player"]["color"];
    $array["colors"]["player"]["button"] = $custom["colors"]["player"]["button"];
    $array["colors"]["player"]["button_active"] = $custom["colors"]["player"]["button_active"];
    $array["colors"]["player"]["seek"] = $custom["colors"]["player"]["seek"];
    $array["colors"]["player"]["progress"] = $custom["colors"]["player"]["progress"];
    $array["colors"]["player"]["timecode"] = $custom["colors"]["player"]["timecode"];
    $array["colors"]["playlist"]["background"] = $custom["colors"]["playlist"]["background"];
    $array["colors"]["playlist"]["color"] = $custom["colors"]["playlist"]["color"];
    $array["colors"]["playlist"]["background_current"] = $custom["colors"]["playlist"]["background_current"];
    $array["colors"]["playlist"]["color_current"] = $custom["colors"]["playlist"]["color_current"];
  }
  
  return $array;
}
  
$label["player"]["background"]["name"] = __('Background', 'wptpa');
$label["player"]["background"]["subname"] = __('main color', 'wptpa');
  
$label["player"]["color"]["name"] = __('Color', 'wptpa');
$label["player"]["color"]["subname"] = __('text color', 'wptpa');
  
$label["player"]["button"]["name"] = __('Button color', 'wptpa');
$label["player"]["button"]["subname"] = __('button color', 'wptpa');
  
$label["player"]["button_active"]["name"] = __('Button color on Action', 'wptpa');
$label["player"]["button_active"]["subname"] = __('button color on hover, or select', 'wptpa');
  
$label["player"]["seek"]["name"] = __('Seek bar color', 'wptpa');
$label["player"]["seek"]["subname"] = __('seek and volume bar color', 'wptpa');
  
$label["player"]["progress"]["name"] = __('Progress bar color', 'wptpa');
$label["player"]["progress"]["subname"] = __('progress and volume value color', 'wptpa');
  
$label["player"]["timecode"]["name"] = __('Time code color', 'wptpa');
$label["player"]["timecode"]["subname"] = __('current time and duration color', 'wptpa');
  
$label["playlist"]["background"]["name"] = __('Background', 'wptpa');
$label["playlist"]["background"]["subname"] = __('main color', 'wptpa');
  
$label["playlist"]["color"]["name"] = __('Color', 'wptpa');
$label["playlist"]["color"]["subname"] = __('text color', 'wptpa');
  
$label["playlist"]["background_current"]["name"] = __('Background on action', 'wptpa');
$label["playlist"]["background_current"]["subname"] = __('main color on hover, or select', 'wptpa');
  
$label["playlist"]["color_current"]["name"] = __('Color on action', 'wptpa');
$label["playlist"]["color_current"]["subname"] = __('text color on hover, or select', 'wptpa');

// сохранение настроек
if(isset($_POST["save"])){
  $settings = checkValues($_POST);
  update_option("wptpa_optn", $settings);
}
// reset settings
if(isset($_POST["reset"])){
  global $def;
  update_option("wptpa_optn", $def);
  // подеменяем настройки
  $optn = checkValues($def);
}

// получаем настройки
$settings = get_option("wptpa_optn");

// если не подхватило новых настроек  
if(!isset($settings["ads_mode"])) {
  $settings["ads_mode"] = "seconds";
}
if(!isset($settings["ads_interval_sec"])) {
  $settings["ads_interval_sec"] = $settings["ads_interval"];
}
if(!isset($settings["ads_interval_song"])) {
  $settings["ads_interval_song"] = 5;
}
if(!isset($settings["cpblts"])){
  $settings["cpblts"]["playlists_page"] = "edit_posts";
  $settings["cpblts"]["statistics_page"] = "edit_posts";
  $settings["cpblts"]["settings_page"] = "edit_posts";
  $settings["cpblts"]["ads_page"] = "edit_posts";
  $settings["cpblts"]["data_page"] = "edit_posts";
}

// получаем цвета темы
if($settings["theme"] !== "custom"){
  $settings["colors"] = themeLoad($settings["theme"]);
}
?>
<div class="wrap">
  <div class="fw_wrapper" style="display: none;">
    <div class="fw_container shadow-depth-0 bg-white-01">
      <h5><?php _e('Player Settings', 'wptpa'); ?></h5>
    </div>
    <!-- TABS --->
    <form action="" method="post" class="fw_container fw_tabs shadow-depth-0 bg-white-01">
      <!-- TABS Header --->
      <div class="fw_tabs-header">
        <ul class="fw_tabs-nav fw_row">
          <li class="fw_column align_center h5 active "><div><?php _e('General', 'wptpa'); ?></div></li>
          <li class="fw_column align_center h5"><div><?php _e('Radio', 'wptpa'); ?></div></li>
          <li class="fw_column align_center h5"><div><?php _e('Advertisement', 'wptpa'); ?></div></li>
          <li class="fw_column align_center h5"><div><?php _e('Themes', 'wptpa'); ?></div></li>
          <li class="fw_column align_center h5"><div><?php _e('Capabilities'); ?></div></li>
        </ul>
        <div class="fw_tabs-border"></div>
      </div>
      <!-- TABS Content --->
      <div class="fw_tabs-content">
        <div class="fw_tabs-slider">
          <!-- TAB 1 --->
          <div class="fw_tab active">
            <?php
              fw_toggleLabel(__('Autoplay', 'wptpa'), __('enable autoplay', 'wptpa'), "autoplay", $settings["autoplay"]);
              fw_dropdownList(__('Preload', 'wptpa'), __('select preload type for audio', 'wptpa'), array(__('Auto', 'wptpa'), __('Metadata', 'wptpa'), __('None', 'wptpa')), array("auto", "metadata", "none"), "preload", $settings["preload"]);
              fw_checkboxLabel(__('Compact mode', 'wptpa'), __('use compact mode by default', 'wptpa'), "compact", $settings["compact"]);
              fw_checkboxLabel(__('Playlist', 'wptpa'), __('show playlist or hide by default', 'wptpa'), "playlist", $settings["playlist"]);
              fw_checkboxLabel(__('Covers', 'wptpa'), __('enable covers', 'wptpa'), "covers", $settings["covers"]);
              fw_toggleLabel(__('Shuffle', 'wptpa'), __('allow shuffle function for users', 'wptpa'), "shuffle", $settings["shuffle"]);
              fw_toggleLabel(__('Sharing', 'wptpa'), __('allow sharing function for users', 'wptpa'), "share", $settings["share"]);
              fw_toggleLabel(__('Embed', 'wptpa'), __('allow embed function for users', 'wptpa'), "embed", $settings["embed"]);
              fw_checkboxLabel(__('Statistics in the playlist', 'wptpa'), __('show count of playing & downloads count of the song', 'wptpa'), "stats", $settings["stats"]);
              fw_inputNumber(__('Volume', 'wptpa'), __('volume value by default', 'wptpa'), "volume", $settings["volume"], "", "", 0, 100, 1);
              fw_inputNumber(__('Playlist Scrolling', 'wptpa'), __('enable scrollbar for playlist (enter 0 to disable)', 'wptpa'), "scrollbar", $settings["scrollbar"], __('after', 'wptpa'), __('songs', 'wptpa'));
              fw_checkboxLabel(__('Player font', 'wptpa'), __('use player font instead of theme font', 'wptpa'), "font", $settings["font"]);
              fw_toggleLabel(__('Open in new window', 'wptpa'), __('allow for users open player in new window', 'wptpa'), "window", $settings["window"]);
            ?>
          </div>
          <!-- TAB 2 --->
          <div class="fw_tab">
            <?php
              fw_checkboxLabel(__('Cover of current playing song', 'wptpa'), __('allow search cover on ITunes for the current playing song', 'wptpa'), "radio_cover", $settings["radio_cover"]);
              fw_inputNumber(__('Interval of update current playing', 'wptpa'), __('get current song information every n seconds', 'wptpa'), "radio_interval", $settings["radio_interval"], __('every', 'wptpa'), __('seconds', 'wptpa'));
            ?>
          </div>
          <!-- TAB 3 --->
          <div class="fw_tab">
            <?php
              fw_toggleLabel(__('Advertisement', 'wptpa'), __('enable playing audio advertisements', 'wptpa'), "ads", $settings["ads"]);
              fw_dropdownList(__('Advertisement mode', 'wptpa'), __('select when play advertisement', 'wptpa'), array(__('Play Advertisement every n Seconds', 'wptpa'), __('Play Advertisement every n Songs', 'wptpa'), __('Play Advertisement Once when Started Playlist', 'wptpa')), array("seconds", "songs", "start"), "ads_mode", $settings["ads_mode"]);
              fw_inputNumber(__('Interval of playing (SECONDS)', 'wptpa'), __('playing advertising every n seconds', 'wptpa'), "ads_interval_sec", $settings["ads_interval_sec"], __('every', 'wptpa'), __('seconds', 'wptpa'));
              fw_inputNumber(__('Interval of playing (SONGS)', 'wptpa'), __('playing advertising every n songs', 'wptpa'), "ads_interval_song", $settings["ads_interval_song"], __('every', 'wptpa'), __('songs', 'wptpa'));
            ?>
          </div>
          <!-- TAB 4 --->
          <div class="fw_tab">
            <?php 
              fw_dropdownList(__('Theme', 'wptpa'), __('select theme for player', 'wptpa'), array(__('Default', 'wptpa'), __('Color Scheme', 'wptpa')." #1", __('Color Scheme', 'wptpa')." #2", __('Color Scheme', 'wptpa')." #3", __('Color Scheme', 'wptpa')." #4", __('Color Scheme', 'wptpa')." #5", __('Color Scheme', 'wptpa')." #6", __('Color Scheme', 'wptpa')." #7", __('Color Scheme', 'wptpa')." #8", __('Color Scheme', 'wptpa')." #9", __('Color Scheme', 'wptpa')." #10", __('Custom', 'wptpa')), array("default", 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, "custom"), "theme", $settings["theme"]);
            ?>
            <div class="fw_row">
              <div class="fw_column lg-12">
                <div class="h5"><?php _e('Player', 'wptpa'); ?></div>
              </div>
            </div>
            <?php
            fw_cp($label["player"], "player", $settings["colors"]["player"]);
            ?>
            <div class="fw_row">
              <div class="fw_column lg-12">
                <h6><?php _e('Playlist', 'wptpa'); ?></h6>
              </div>
            </div>
            <?php
            fw_cp($label["playlist"], "playlist", $settings["colors"]["playlist"]);
            ?>
            <div class="fw_row">
              <div class="fw_column lg-12">
                <h6>Preview</h6>
              </div>
            </div>
            <div class="fw_row">
              <div class="fw_column lg-12 wptpa_preview">
                <div class="wptpa_style_css"></div>
                <div class="wptpa_wrapper">
                  <div class="wptpa_player_container tooltip_elmnt">
                    <div class="wptpa_cvr_wrapper">
                      <ul class="wptpa_covers">
                        <li class="wptpa_cover">
                          <img src="<?php echo WPTPA_URL; ?>assets/img/logo.svg">
                        </li>
                      </ul>
                    </div>
                    <div class="wptpa_player">
                      <div class="wptpa_heading">
                        <div class="wptpa_song_infrmtn" title="Artist - Title" style="top: 0px;"><b>Artist</b> - Title</div>
                      </div>
                      <div class="wptpa_control">
                        <div class="wptpa_playback wptpa_btn"></div>
                        <div class="wptpa_seek">
                          <div class="wptpa_progress" style="width: 50%;"></div>
                          <div class="wptpa_currenttime">00:00</div>
                          <div class="wptpa_duration">03:32</div>
                        </div>
                        <div class="wptpa_prev wptpa_btn"></div>
                        <div class="wptpa_repeat wptpa_btn"></div>
                        <div class="wptpa_next wptpa_btn"></div>
                        <div class="wptpa_shuffle wptpa_btn"></div>
                        <div class="wptpa_share wptpa_btn"></div>
                      </div>
                      <div class="wptpa_additional">
                        <div class="wptpa_pls_toggle wptpa_btn"></div>
                        <div class="wptpa_volume_control">
                          <div class="wptpa_volume wptpa_btn"></div>
                          <div class="wptpa_volume_seek">
                            <div class="wptpa_volume_value" style="width: 50%;"></div>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                  <div class="wptpa_pllst_container tooltip_elmnt">
                    <ul class="wptpa_pllst plsopn">
                      <li class="wptpa_pllst_itm">
                        <div class="wptpa_curent">
                          <div class="wptpa_bars"></div>
                        </div>
                        <div class="wptpa_song" title="Artist - Title"><b>Artist</b> - Title</div>
                        <hr class="wptpa_line">
                        <div class="wptpa_dwn_cnt" title="100 Downloads">100</div>
                        <hr class="wptpa_line">
                        <div class="wptpa_play_cnt" title="100 Plays">100</div>
                        <hr class="wptpa_line">
                        <a target="_blank" title="Buy" href="#" class="wptpa_buy wptpa_icon"></a>
                        <hr class="wptpa_line">
                        <a download="" title="Download" target="_blank" href="#" class="wptpa_dwn wptpa_icon"></a>
                      </li>
                      <li class="wptpa_pllst_itm crrnt">
                        <div class="wptpa_curent">
                          <div class="wptpa_bars"></div>
                        </div>
                        <div class="wptpa_song" title="Artist - Title"><b>Artist</b> - Title</div>
                        <hr class="wptpa_line">
                        <div class="wptpa_dwn_cnt" title="100 Downloads">100</div>
                        <hr class="wptpa_line">
                        <div class="wptpa_play_cnt" title="100 Plays">100</div>
                        <hr class="wptpa_line">
                        <a target="_blank" title="Buy" href="#" class="wptpa_buy wptpa_icon"></a>
                        <hr class="wptpa_line">
                        <a download="" title="Download" target="_blank" href="#" class="wptpa_dwn wptpa_icon"></a>
                      </li>
                      <li class="wptpa_pllst_itm">
                        <div class="wptpa_curent">
                          <div class="wptpa_bars"></div>
                        </div>
                        <div class="wptpa_song" title="Artist - Title"><b>Artist</b> - Title</div>
                        <hr class="wptpa_line">
                        <div class="wptpa_dwn_cnt" title="100 Downloads">100</div>
                        <hr class="wptpa_line">
                        <div class="wptpa_play_cnt" title="100 Plays">100</div>
                        <hr class="wptpa_line">
                        <a target="_blank" title="Buy" href="#" class="wptpa_buy wptpa_icon"></a>
                        <hr class="wptpa_line">
                        <a download="" title="Download" target="_blank" href="#" class="wptpa_dwn wptpa_icon"></a>
                      </li>
                    </ul>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <!-- TAB 5 --->
          <div class="fw_tab">
            <?php
              $roles = [__("Super Admin"), __("Administrator"), __("Editor"), __("Author"), __("Contributor"), __("Subscriber")];
              $capabilities = ["create_sites", "install_plugins", "edit_pages", "publish_posts", "edit_posts", "read"];
              fw_dropdownList(__('Playlist Generator', 'wptpa'), __('select who have capabilities for this page', 'wptpa'), $roles, $capabilities, "cpblts[playlists_page]", $settings["cpblts"]["playlists_page"]);
              fw_dropdownList(__('Songs Statistics', 'wptpa'), __('select who have capabilities for this page', 'wptpa'), $roles, $capabilities, "cpblts[statistics_page]", $settings["cpblts"]["statistics_page"]);
              fw_dropdownList(__('Player Settings', 'wptpa'), __('select who have capabilities for this page', 'wptpa'), $roles, $capabilities, "cpblts[settings_page]", $settings["cpblts"]["settings_page"]);
              fw_dropdownList(__('Advertising Manager  (Beta)', 'wptpa'), __('select who have capabilities for this page', 'wptpa'), $roles, $capabilities, "cpblts[ads_page]", $settings["cpblts"]["ads_page"]);
              fw_dropdownList(__('Import/Export Data', 'wptpa'), __('select who have capabilities for this page', 'wptpa'), $roles, $capabilities, "cpblts[data_page]", $settings["cpblts"]["data_page"]);
            ?>
          </div>
        </div>
      </div>
      <!-- TABS Footer --->
      <div class="fw_tabs-footer">
        <div class="fw_row">
          <div class="fw_column lg-12 align_end">
            <button type="submit" name="reset" value="reset" class="fw_btn flat">Reset to default</button>
            <button type="submit" name="save" value="save" class="fw_btn">Save</button>
          </div>
        </div>
      </div>
    </form>
    
  </div>
</div>
<?php
}
?>