<?php
function wptpa_function($atts) {
  extract(shortcode_atts(array(
    "id" => '',
    "wrapperid" => '',
    "autoplay" => '',
    "playlist" => '',
    "cover" => '',
    "compact" => '',
    "cursng" => '',
    "curtm" => '',
    "curvlm" => '',
  ), $atts));
  // Подключаем стили и скрипты
  wp_enqueue_style('wptpa_player-style', WPTPA_URL.'assets/css/wptpa_style.css');
  wp_enqueue_script('jquery');
  wp_enqueue_script('jquery-effects-core');
  wp_enqueue_script('jquery-ui-slider');
  wp_enqueue_script('jquery.ui.touch-punch.min', WPTPA_URL.'assets/js/jquery.ui.touch-punch.min.js', array('jquery-ui-slider'));
  wp_enqueue_script('jquery.easing', WPTPA_URL.'assets/js/jquery.easing.js', array('jquery'));
  wp_enqueue_script('ResizeSensor-script', WPTPA_URL.'assets/js/ResizeSensor.js', array('jquery'));
  wp_enqueue_script('wptpa_player-script', WPTPA_URL.'assets/js/wptpa_script.js', array('jquery'));
  // обьявляем данные для работы скрипта
  wp_localize_script('wptpa_player-script', 'wptpa_data', array(
    'ajaxurl' => admin_url('admin-ajax.php'),
    'siteurl' => get_site_url())
  );
    
  global $wpdb;
  $songs_table_name = $wpdb->prefix."tpa_songs";
  $pls_table_name = $wpdb->prefix."tpa_playlist";
  $stats_table_name = $wpdb->prefix."tpa_statistics";
  $wptpa_settings = get_option("wptpa_optn");
  
  //$unicID = "playlist_".$id;
  $unicID = wptpa_randomID();
  // fix
  if(isset($atts["playlist"])){
    $atts["showPls"] = $atts["playlist"];
  }
  if(isset($atts["compact"])){
    $atts["compactMode"] = $atts["compact"];
  }
  if(!isset($atts["compactMode"]) AND !isset($wptpa_settings["compact"])){
    $wptpa_settings["compact"] = false;
  }
  // перевеоди в буль
  foreach($atts as $k => $v){
    if($v == "false"){
      $atts[$k] = false;
    }
    if($v == "true"){
      $atts[$k] = true;
    }
  }
  // обьеденяем массивы
  $wptpa_settings = array_merge ($wptpa_settings, $atts);
  // формируем настройки
  if(!empty($wrapperid)){
    $unicID = "preview";
  }
  if(empty($cursng)){
    $cursng = 0;
  }
  if(empty($curtm)){
    $curtm = 0;
  }
  if(!empty($curvlm)){
    $wptpa_settings["volume"] = $curvlm;
  }
  if(!isset($wptpa_settings["radio_cover"])){
    $wptpa_settings["radio_cover"] = false;
  }
  if(!isset($wptpa_settings["radio_interval"])){
    $wptpa_settings["radio_interval"] = 30;
  }
  $preload = isset($wptpa_settings['preload']) ? $wptpa_settings['preload'] : 'auto';
  $autoplay = ($wptpa_settings['autoplay']) ? 'true' : 'false';
  $compactMode = ($wptpa_settings['compact']) ? 'true' : 'false';
  $showPlaylist = ($wptpa_settings['playlist']) ? 'true' : 'false';
  $defaultVolume = $wptpa_settings['volume'];
  $shuffle = ($wptpa_settings['shuffle']) ? 'true' : 'false';
  $share = ($wptpa_settings['share']) ? 'true' : 'false';
  $embed = ($wptpa_settings['embed']) ? 'true' : 'false';
  $window = ($wptpa_settings['window']) ? 'true' : 'false';
  $scrollbar = $wptpa_settings['scrollbar'];
  $ads = ($wptpa_settings['ads']) ? 'true' : 'false';
  $adsMode = isset($wptpa_settings['ads_mode']) ? $wptpa_settings['ads_mode'] : 'seconds';
  // если есть новые настройки
  if(isset($wptpa_settings["ads_interval_sec"])) {
    $ads_interval_sec = intval($wptpa_settings["ads_interval_sec"]);
  } else {
    // если нету проверяем настройки предыдущей версии
    if(isset($wptpa_settings["ads_interval"])) {
      $ads_interval_sec = intval($wptpa_settings["ads_interval"]);
    } else {
      $ads_interval_sec = 30;
    }
  }
  
  $ads_interval_song = isset($wptpa_settings["ads_interval_song"]) ? intval($wptpa_settings["ads_interval_song"]) : 5;
  $ads_url = isset($wptpa_settings['ads_url']) ? $wptpa_settings['ads_url'] : null;
  $stats = ($wptpa_settings['stats']) ? 'true' : 'false';
  $covers = ($wptpa_settings['covers']) ? 'true' : 'false';
  $radio_cover = ($wptpa_settings['radio_cover']) ? 'true' : 'false';
  $radio_interval = $wptpa_settings['radio_interval'];
  // если есть айди
  switch($id) {
    case "default":
      $pls = false;
      break;
    case "topweek":
      $topweek = $wpdb->get_results("SELECT song_id, SUM(count) AS weekcount FROM $stats_table_name WHERE date > NOW() - INTERVAL 7 DAY GROUP BY song_id ORDER BY weekcount DESC LIMIT 0,10", ARRAY_A);
      if($topweek){
        if(count($topweek) >= 10){
          $pls["id"] = "topweek";
          $pls["name"] = "topweek";
          foreach($topweek as $k => $v){
            $pls["items"][] = $v["song_id"];
          }
          $pls["items"] = serialize($pls["items"]);
        } else {
          $pls = false;
        }
      } else {
        $pls = false;
      }
      break;
    case "topmonth":
      $topmonth = $wpdb->get_results("SELECT song_id, SUM(count) AS monthcount FROM $stats_table_name WHERE date > NOW() - INTERVAL 30 DAY GROUP BY song_id ORDER BY monthcount DESC LIMIT 0,10", ARRAY_A);
      if($topmonth) {
        if(count($topmonth) >= 10) {
          $pls["id"] = "topmonth";
          $pls["name"] = "topmonth";
          foreach($topmonth as $k => $v){
            $pls["items"][] = $v["song_id"];
          }
          $pls["items"] = serialize($pls["items"]);
        } else {
          $pls = false;
        }
      } else {
        $pls = false;
      }
      break;
    case "mostplayed":
      $mostPlayed = $wpdb->get_results("SELECT * FROM $songs_table_name ORDER BY `all_count` DESC LIMIT 0,10", ARRAY_A);
      if($mostPlayed) {
        if(count($mostPlayed) >= 10) {
          $pls["id"] = "mostplayed";
          $pls["name"] = "mostplayed";
          foreach($mostPlayed as $k => $v){
            $pls["items"][] = $v["id"];
          }
          $pls["items"] = serialize($pls["items"]);
        } else {
          $pls = false;
        }
      } else {
        $pls = false;
      }
      break;
    default:
      $pls = $wpdb->get_row("SELECT * FROM $pls_table_name WHERE id = ".$id, ARRAY_A);
      break;
  }
  /*
  if($id AND $id != "default"){
    // проверяем если выбран топ 10 выводим его, если нет просто плс
    if($id != "topweek"){
      $pls = $wpdb->get_row("SELECT * FROM $pls_table_name WHERE id = ".$id, ARRAY_A);
    } else {
      $topweek = $wpdb->get_results("SELECT song_id, SUM(count) AS weekcount FROM $stats_table_name WHERE date > NOW() - INTERVAL 7 DAY GROUP BY song_id ORDER BY weekcount DESC LIMIT 0,10", ARRAY_A);
      if($topweek){
        if(count($topweek) >= 10){
          $pls["id"] = "topweek";
          $pls["name"] = "topweek";
          foreach($topweek as $k => $v){
            $pls["items"][] = $v["song_id"];
          }
          $pls["items"] = serialize($pls["items"]);
        }
      }
    }
  } else {
    $pls = false;
  }*/
    
  //если есть плейлист
  if($pls){
    // конвертируем список песен в массив
    $sngs_id = unserialize($pls["items"]);
    // получаем треки
    foreach($sngs_id as $k => $v){
      $wptpa_songs[] = $wpdb->get_row("SELECT * FROM $songs_table_name WHERE id = $v", "ARRAY_A");
    }
    // переводим в json
    $wptpa_current_pls = json_encode($wptpa_songs);
    // избавляемся от юникода
    $wptpa_current_pls = wptpa_unescapted($wptpa_current_pls);
    // избавляемся от лишних слешей
    $wptpa_current_pls = stripslashes($wptpa_current_pls);
    
     //shuffle mode если прислали куки
    if(isset($_COOKIE["shuffle"])){
      $shuffleOn = 'true'; 
    } else {
      $shuffleOn = 'false';
    }
     //volume mode если прислали куки
    if(isset($_COOKIE["volume"])){
      $defaultVolume = $_COOKIE["volume"]; 
    }
    $ads_list = get_option("wptpa_ads_list");
    // переводим в json
    if($ads_list) {
      $ads_list = json_encode(array_values($ads_list));
      // избавляемся от юникода
      $ads_list = wptpa_unescapted($ads_list);
      // избавляемся от лишних слешей
      $ads_url = stripslashes($ads_list);
    } else {
      $ads_url = null;
    }
    
    $script = "
    jQuery(document).ready(function ($) {
      $('#$unicID').wptpa({
        playlist: $wptpa_current_pls,
        playlistId: '$id',
        autoplay: $autoplay,
        cursng: $cursng,
        curtm: $curtm,
        preload: '$preload',
        compactMode: $compactMode,
        showPls: $showPlaylist,
        shuffleOn: $shuffleOn,
        shuffle: $shuffle,
        share: $share,
        embed: $embed,
        window: $window,
        volume: $defaultVolume,
        scroll: $scrollbar,
        sharetext: '',
        ads: $ads,
        adsMode: '$adsMode',
        adsIntervalSeconds: $ads_interval_sec,
        adsIntervalSongs: $ads_interval_song,
        adsUrl: '$ads_url',
        stats: $stats,
        covers: $covers,
        coverRadio: $radio_cover,
        radioInterval: $radio_interval
      });
    });";
    
    wp_add_inline_script("wptpa_player-script", $script);
    // fix for divi buider
    if(isset($_GET["et_pb_preview"])){
      return '<div class="wrapper" id="'.$unicID.'"></div><style type="text/css">'.$custom_css.'</style>';
    } else {
      return '<div class="wrapper" id="'.$unicID.'"></div>';
    }
    
  } else {
    //если нет плейлиста
    return '<div style="width:100%;padding: 50px; background: #f2f2f2;color: #555; font-size: 25px; line-height: 30px; text-align: center; -webkit-box-sizing: border-box; -moz-box-sizing: border-box; box-sizing: border-box;">Oops, the playlist you\'re looking for doesn\'t exist.</div>';
  }
}
add_shortcode('wptpa', 'wptpa_function');
// Разрешаем шорткод в виджете
//add_filter('widget_text', 'do_shortcode');
?>