(function (window) {
  "use strict";
  var notifyFW = (function () {
    var template = "";
    template += '<div class="fw_notify_container fw_container shadow-depth-5 bg-white-01">';
    template += '  <div class="fw_row">';
    template += '    <div class="fw_column lg-10">';
    template += '      <div class="h6">{heading}</div>';
    template += '    </div>';
    template += '    <div class="fw_column lg-2 align_end"><i class="fas fa-times fw_close fw_close_noytify"></i></div>';
    template += '  </div>';
    template += '  <div class="fw_row">';
    template += '    <div class="fw_column lg-12">{text}</div>';
    template += '  </div>';
    template += '</div>';
      
    function send(options) {
      var settings = jQuery.extend({
        'heading': "",
        'text' : ""
      }, options),
        $elements;

      $elements = jQuery(template.replace('{heading}', settings.heading).replace('{text}', settings.text));
        
      jQuery(".fw_notify_wrapper").append($elements);

      $elements.slideDown(250);
      
      // remove after 5 sec
      setTimeout(function () {
        $elements.slideUp(250);
        setTimeout(function () {
          $elements.remove();
        }, 5000);
      }, 5000);
      
      jQuery(document).on("click", ".fw_close_noytify", function(){
        var msg = jQuery(this).parent().parent().parent();
        msg.slideUp(250);
          
        setTimeout(function () {
          msg.remove();
        }, 5000);
      });
      
    }

    return {
      send: send
    };
  }());

  window.notifyFW = notifyFW;

}(window));
