<?php
function wptpa_data_page() {
  global $wpdb;
  $notify = "";
  //import sql
  if(!empty($_FILES)) {
    $sql = file_get_contents($_FILES["wptpa_sql_file"]["tmp_name"]);
    $array = explode("INSERT", $sql);
    $result = array_filter($array);
    $tables = [__('Songs', 'wptpa'), __('Playlists', 'wptpa'), __('Statistics', 'wptpa')];
    if($result) {
      $i = 0;
      foreach($result as $k => $v){
        $q = $wpdb->query("INSERT$v");
        if($q) {
          $msg = "<b>".$tables[$i]."</b>".__(' was Imported', 'wptpa');
          $notify .= 'notifyFW.send({"heading": "'.__("Import", 'wptpa').'","text": "'.$msg.'"});';
          $i++;
        } else {
          $msg = __('Something goes wrong, please write to support, for help.', 'wptpa');
          $notify .= 'notifyFW.send({"heading": "'.__("Import", 'wptpa').'","text": "'.$msg.'"});';
          break;
        }
      }
    }
  }
  
  $heading = __('Import/Export DATA', 'wptpa'); // заголовок
?>

<div class="wrap">
  <div class="fw_wrapper" style="display: none;">
    <div class="fw_container shadow-depth-0 bg-white-01">
     <div class="fw_row">
       <div class="fw_column lg-6">
         <div class="h5"><?php echo $heading; ?></div>
       </div>
       <div class="fw_column lg-6 align_end">
         <form action="" method="POST" name="wptpa_import_form" enctype="multipart/form-data" id="wptpa_import_form">
           <button id="wptpa_import_button" class="fw_btn sml flat"><i class="fas fa-file-import"></i><?php _e('Import', 'wptpa'); ?></button>
           <input type="file" id="wptpa_import_input" name="wptpa_sql_file">
         </form>
         
         <button id="wptpa_export" class="fw_btn sml flat"><i class="fas fa-file-export"></i><?php _e('Export', 'wptpa'); ?></button>
       </div>
     </div>
    </div>
    <div class="fw_container shadow-depth-0 bg-white-01">
     <div class="fw_row">
       <div class="fw_column lg-12 align_center">
        <div class="wptpa_block txt_align_center" style="padding: 50px;">
          <textarea name="" id="exportData"></textarea>
          <i class="fas fa-info-circle fa-3x" style="margin-bottom: 10px; color: #3EC3D5;"></i>
          <div class="h6"><?php _e("Please click \"Export\" for Export or just click \"Import\" for import tPlayer data", "wptpa"); ?></div>
        </div>
       </div>
     </div>
     <div class="fw_row data_prepare">
       <div class="fw_column lg-12 align_center">
         <h4><?php _e("Data Preparation...", "wptpa"); ?></h4>
       </div>
     </div>
     <div class="fw_row data_loading">
       <div class="fw_column lg-12 align_center">
         <i class="fas fa-circle-notch fa-2x fa-spin" style="color: #3EC3D5;"></i>
       </div>
     </div>
     <div class="fw_row data_ready_export">
       <div class="fw_column lg-12 align_center">
         <h6 style="color: #3EC3D5;"><?php _e("Ready for Export :)", "wptpa"); ?></h6>
       </div>
     </div>
    </div>
    <div class="fw_notify_wrapper"></div>
  </div>
</div>
  <script>
  jQuery(document).ready(function($){
    <?php echo $notify; ?>
  });
  </script>
<?php
}
?>