<?php

function wptpa_help_page() {
?>
<div class="wrap">
  <div class="fw_wrapper" style="display: none;">
    <div class="fw_container shadow-depth-0 bg-blue-01 txt-white-01" style="text-transform: uppercase;">
     <div class="fw_row">
       <div class="fw_column lg-12 align_end align_middle">
         <div class="h4"><?php _e('Follow us on Facebook', 'wptpa'); ?></div>
         <a href="https://www.facebook.com/be.in.dtc/" target="_blank" style="padding: 7px 10px;height: 30px;" class="fw_btn white"><i class="fab fa-facebook-f"></i><?php _e('Join', 'wptpa'); ?></a>
       </div>
     </div>
    </div>
    <div class="fw_container shadow-depth-0 bg-white-01">
     <div class="fw_row">
       <div class="fw_column lg-12">
         <div class="h4 txt-blue-01"><?php _e('Player', 'wptpa'); ?></div>
       </div>
     </div>
    </div>
    
    <div class="fw_container bg-white-01 shadow-depth-0">
      <h5 class="fw_accordion_toggle"><?php _e('How to disable song covers?', 'wptpa'); ?></h5>
      <div class="fw_row fw_accordion_content">
        <div class="fw_column lg-12">
          <div class="fw_subheading"><b><?php _e('Go to', 'wptpa'); ?></b> <b class="txt-blue-01"> tPlayer > <?php _e('Player Settings', 'wptpa'); ?></b></div>
          <ol class="fw_num_list">
            <li><?php _e('In <b>General</b> tab find option <b>Covers</b>.', 'wptpa'); ?></li>
            <li><?php _e('Uncheck option.', 'wptpa'); ?></li>
            <li><?php _e('Click <b>Save</b> button.', 'wptpa'); ?></li>
          </ol>
        </div>
      </div>
      <h5 class="fw_accordion_toggle"><?php _e('How to add scroll to a Playlist?', 'wptpa'); ?></h5>
      <div class="fw_row fw_accordion_content">
        <div class="fw_column lg-12">
          <div class="fw_subheading"><b><?php _e('Go to', 'wptpa'); ?></b> <b class="txt-blue-01"> tPlayer > <?php _e('Player Settings', 'wptpa'); ?></b></div>
          <ol class="fw_num_list">
            <li><?php _e('In <b>General</b> tab find option <b>Playlist Scrolling</b>.', 'wptpa'); ?></li>
            <li><?php _e('Enter the number of vissible songs in playlist.', 'wptpa'); ?></li>
            <li><?php _e('Click <b>Save</b> button.', 'wptpa'); ?></li>
          </ol>
        </div>
      </div>
      <h5 class="fw_accordion_toggle"><?php _e('How to add Advertisement audio?', 'wptpa'); ?></h5>
      <div class="fw_row fw_accordion_content">
        <div class="fw_column lg-12">
          <div class="fw_subheading"><b><?php _e('Go to', 'wptpa'); ?></b> <b class="txt-blue-01"> tPlayer > <?php _e('Advertising Manager', 'wptpa'); ?></b></div>
          <ol class="fw_num_list">
            <li><?php _e('Click <b><i class="fas fa-plus"></i> Add</b> button.', 'wptpa'); ?></li>
            <li><?php _e('In the modal window, Click <b>Browse</b> to select audio or type the link to audio file.(You can select multiple songs with <b>ctrl</b> button).', 'wptpa'); ?></li>
            <li><?php _e('Edit <b>Name</b> field.', 'wptpa'); ?></li>
            <li><?php _e('Click <b>Save</b> button.', 'wptpa'); ?></li>
          </ol>
        </div>
      </div>
      <h5 class="fw_accordion_toggle"><?php _e('How to enable Advertisement audio?', 'wptpa'); ?></h5>
      <div class="fw_row fw_accordion_content">
        <div class="fw_column lg-12">
          <div class="fw_subheading"><b><?php _e('Go to', 'wptpa'); ?></b> <b class="txt-blue-01"> tPlayer > <?php _e('Player Settings', 'wptpa'); ?></b></div>
          <ol class="fw_num_list">
            <li><?php _e('In <b>Advertisement</b> tab find option <b>Advertising</b> and check it.', 'wptpa'); ?></li>
            <li><?php _e('Select type of <b>Advertising Mode</b>.', 'wptpa'); ?></li>
            <li><?php _e('Click <b>Save</b> button.', 'wptpa'); ?></li>
          </ol>
        </div>
      </div>
      <h5 class="fw_accordion_toggle"><?php _e('How to add a player to a post?', 'wptpa'); ?></h5>
      <div class="fw_row fw_accordion_content">
        <div class="fw_column lg-12">
          <ol class="fw_num_list">
            <li><?php _e('Create a new post/page or Edit old.', 'wptpa'); ?></li>
            <li><?php _e('Click <b>Add tPlayer</b> button. Or find "tPlayer" block in <b>Gutenberg</b>.', 'wptpa'); ?></li>
            <li><?php _e('Select playlist.', 'wptpa'); ?></li>
            <li><?php _e('Click <b>Ok</b> button for adding player to a post.', 'wptpa'); ?></li>
            <li><?php _e('Save your post.', 'wptpa'); ?></li>
          </ol>
        </div>
      </div>
      <h5 class="fw_accordion_toggle"><?php _e('How to use player as widget?', 'wptpa'); ?></h5>
      <div class="fw_row fw_accordion_content">
        <div class="fw_column lg-12">
          <div class="fw_subheading"><b><?php _e('Go to', 'wptpa'); ?></b> <b class="txt-blue-01"> <?php _e('Appearance'); ?> > <?php _e('Widgets'); ?></b></div>
          <ol class="fw_num_list">
            <li><?php _e('Select tPlayer widget and add to widget area.', 'wptpa'); ?></li>
            <li><?php _e('Enter title for widget.', 'wptpa'); ?></li>
            <li><?php _e('Select playlist.', 'wptpa'); ?></li>
            <li><?php _e('Click <b>Save</b> button for adding widget.', 'wptpa'); ?></li>
          </ol>
        </div>
      </div>
    </div>
  
  
    <div class="fw_container bg-white-01 shadow-depth-0">
     <div class="fw_row">
       <div class="fw_column lg-12">
         <div class="h4 txt-blue-01"><?php _e('Playlist', 'wptpa'); ?></div>
       </div>
     </div>
    </div>


    <div class="fw_container bg-white-01 shadow-depth-0">
      <h5 class="fw_accordion_toggle"><?php _e('How to Create a Playlist?', 'wptpa'); ?></h5>
      <div class="fw_row fw_accordion_content">
        <div class="fw_column lg-12">
          <div class="fw_subheading"><b><?php _e('Go to', 'wptpa'); ?></b> <b class="txt-blue-01"> tPlayer > <?php _e('Playlist Generator', 'wptpa'); ?></b></div>
          <ol class="fw_num_list">
            <li><?php _e('Click <b><i class="fas fa-plus"></i> Create</b> button.', 'wptpa'); ?></li>
            <li><?php _e('Enter the playlist name.', 'wptpa'); ?></li>
            <li><?php _e('Add songs.', 'wptpa'); ?></li>
            <li><?php _e('Save your playlist.', 'wptpa'); ?></li>
          </ol>
        </div>
      </div>
      <h5 class="fw_accordion_toggle"><?php _e('How to Edit a Playlist?', 'wptpa'); ?></h5>
      <div class="fw_row fw_accordion_content">
        <div class="fw_column lg-12">
          <div class="fw_subheading"><b><?php _e('Go to', 'wptpa'); ?></b> <b class="txt-blue-01"> tPlayer > <?php _e('Playlist Generator', 'wptpa'); ?></b></div>
          <ol class="fw_num_list">
            <li><?php _e('Сlick on the name of the playlist.', 'wptpa'); ?></li>
            <li><?php _e('Change a playlist.', 'wptpa'); ?></li>
            <li><?php _e('Save your playlist.', 'wptpa'); ?></li>
          </ol>
        </div>
      </div>
      <h5 class="fw_accordion_toggle"><?php _e('How to Clone a Playlist?', 'wptpa'); ?></h5>
      <div class="fw_row fw_accordion_content">
        <div class="fw_column lg-12">
          <div class="fw_subheading"><b><?php _e('Go to', 'wptpa'); ?></b> <b class="txt-blue-01"> tPlayer > <?php _e('Playlist Generator', 'wptpa'); ?></b></div>
          <ol class="fw_num_list">
            <li><?php _e('Opposite to the desired playlist, in the <b>Action</b> column, click on the <b><i class="fas fa-ellipsis-v"></i></b> icon.', 'wptpa'); ?></li>
            <li><?php _e('In the drop-down list, select <b><i class="fas fa-copy"></i> Clone</b>.', 'wptpa'); ?></li>
          </ol>
        </div>
      </div>
      <h5 class="fw_accordion_toggle"><?php _e('How to Delete a Playlist?', 'wptpa'); ?></h5>
      <div class="fw_row fw_accordion_content">
        <div class="fw_column lg-12">
          <div class="fw_subheading"><b><?php _e('Go to', 'wptpa'); ?></b> <b class="txt-blue-01"> tPlayer > <?php _e('Playlist Generator', 'wptpa'); ?></b></div>
          <ol class="fw_num_list">
            <li><?php _e('Opposite the desired playlist, in the column <b>Action</b>, click on <b><i class="fas fa-ellipsis-v"></i></b> icon.', 'wptpa'); ?></li>
            <li><?php _e('In the drop-down list, select <b><i class="fas fa-trash-alt"></i> Delete</b>.', 'wptpa'); ?></li>
          </ol>
        </div>
      </div>
      <h5 class="fw_accordion_toggle"><?php _e('How to Delete Playlists?', 'wptpa'); ?></h5>
      <div class="fw_row fw_accordion_content">
        <div class="fw_column lg-12">
          <div class="fw_subheading"><b><?php _e('Go to', 'wptpa'); ?></b> <b class="txt-blue-01"> tPlayer > <?php _e('Playlist Generator', 'wptpa'); ?></b></div>
          <ol class="fw_num_list">
            <li><?php _e('Use checkbox to select playlists.', 'wptpa'); ?></li>
            <li><?php _e('Click <b><i class="fas fa-trash-alt"></i> Delete</b> button.', 'wptpa'); ?></li>
          </ol>
        </div>
      </div>
      <h5 class="fw_accordion_toggle"><?php _e('How to Add songs to the Playlist?', 'wptpa'); ?></h5>
      <div class="fw_row fw_accordion_content">
        <div class="fw_column lg-12">
          <div class="fw_subheading"><b><?php _e('Go to', 'wptpa'); ?></b> <b class="txt-blue-01"> tPlayer > <?php _e('Playlist Generator', 'wptpa'); ?></b></div>
          <ol class="fw_num_list">
            <li><?php _e('Click <b><i class="fas fa-plus"></i> Add</b> button.', 'wptpa'); ?></li>
            <li><?php _e('In the modal window, Click <b>Browse</b> to select audio.(You can select multiple songs with <b>ctrl</b> button).', 'wptpa'); ?></li>
            <li><?php _e('If wordpress does not load the song information, edit <b>Artist</b>, <b>Title</b> and <b>Cover</b> fields.', 'wptpa'); ?></li>
            <li><?php _e('Click <b>Save</b> button.', 'wptpa'); ?></li>
          </ol>
        </div>
      </div>
      <h5 class="fw_accordion_toggle"><?php _e('How to Edit songs in the Playlist?', 'wptpa'); ?></h5>
      <div class="fw_row fw_accordion_content">
        <div class="fw_column lg-12">
          <div class="fw_subheading"><b><?php _e('Go to', 'wptpa'); ?></b> <b class="txt-blue-01"> tPlayer > <?php _e('Playlist Generator', 'wptpa'); ?></b></div>
          <ol class="fw_num_list">
            <li><?php _e('Use checkbox to select songs.', 'wptpa'); ?></li>
            <li><?php _e('Click <b><i class="fas fa-pencil-alt"></i> Edit</b> button.', 'wptpa'); ?></li>
            <li><?php _e('In the modal window edit song information.', 'wptpa'); ?></li>
            <li><?php _e('Click <b>Save</b> button.', 'wptpa'); ?></li>
          </ol>
        </div>
      </div>
    </div>


    <div class="fw_container bg-white-01 shadow-depth-0">
     <div class="fw_row">
       <div class="fw_column lg-12">
         <div class="h4 txt-blue-01"><?php _e('Radio', 'wptpa'); ?></div>
       </div>
     </div>
    </div>


    <div class="fw_container bg-white-01 shadow-depth-0">
      <h5 class="fw_accordion_toggle"><?php _e('How to add Radio?', 'wptpa'); ?></h5>
      <div class="fw_row fw_accordion_content">
        <div class="fw_column lg-12">
          <div class="fw_subheading"><b><?php _e('Go to', 'wptpa'); ?></b> <b class="txt-blue-01"> tPlayer > <?php _e('Playlist Generator', 'wptpa'); ?></b></div>
          <ol class="fw_num_list">
            <li><?php _e('Select or create a playlist.', 'wptpa'); ?></li>
            <li><?php _e('Click <b><i class="fas fa-plus"></i> Add</b> button.', 'wptpa'); ?></li>
            <li><?php _e('In the <b>Artist</b> field enter the station name.', 'wptpa'); ?></li>
            <li><?php _e('The <b>Title</b> field can be empty.', 'wptpa'); ?></li>
            <li><?php _e('In the <b>Audio url</b> field add a link to radio stream.', 'wptpa'); ?>
              <ul>
                <li><?php _e('<b>Shoutcast v1:</b><br>You need to add to your link stream ";stream/1".<br><b>Example:</b><br>http://127.0.0.1:80/<b>;stream/1</b><br><br>', 'wptpa'); ?></li>
                <li><?php _e('<b>Shoutcast v2:</b><br>You need to add to your link number of sid "stream/3".<br><b>Example:</b><br>http://127.0.0.1:80/<b>stream/3</b><br><br>', 'wptpa'); ?></li>
                <li><?php _e('<b>Icecast:</b><br>You need to add to your link mount.<br><b>Example:</b><br>http://127.0.0.1:80/<b>your_mount</b><br><br>', 'wptpa'); ?></li>
              </ul>
            </li>
            <li><?php _e('In the <b>Cover url</b> filed add your radio logo.', 'wptpa'); ?></li>
            <li><?php _e('Click <b>Save</b> button.', 'wptpa'); ?></li>
          </ol>
        </div>
      </div>
      <h5 class="fw_accordion_toggle"><?php _e('How to enable search covers for current song (Radio)?', 'wptpa'); ?></h5>
      <div class="fw_row fw_accordion_content">
        <div class="fw_column lg-12">
          <div class="fw_subheading"><b><?php _e('Go to', 'wptpa'); ?></b> <b class="txt-blue-01"> tPlayer > <?php _e('Player Settings', 'wptpa'); ?></b></div>
          <ol class="fw_num_list">
            <li><?php _e('In the <b>Radio</b> tab find option <b>Cover of current playing song</b>.', 'wptpa'); ?></li>
            <li><?php _e('Check option.', 'wptpa'); ?></li>
            <li><?php _e('Click <b>Save</b> button.', 'wptpa'); ?></li>
          </ol>
        </div>
      </div>
      <h5 class="fw_accordion_toggle"><?php _e('How to set the interval of information update for the current song (Radio)?', 'wptpa'); ?></h5>
      <div class="fw_row fw_accordion_content">
        <div class="fw_column lg-12">
          <div class="fw_subheading"><b><?php _e('Go to', 'wptpa'); ?></b> <b class="txt-blue-01"> tPlayer > <?php _e('Player Settings', 'wptpa'); ?></b></div>
          <ol class="fw_num_list">
            <li><?php _e('In the <b>Radio</b> tab find option <b>Interval of update current playing</b>.', 'wptpa'); ?></li>
            <li><?php _e('Enter the interval of update in seconds.', 'wptpa'); ?></li>
            <li><?php _e('Click <b>Save</b> button.', 'wptpa'); ?></li>
          </ol>
        </div>
      </div>
    </div>
  
  
  </div>
</div>
<?php
}
?>